#include <QtGui>

#include "FormAdd.h"

FormAdd::FormAdd(QWidget *parent) : QDialog(parent)
{
	setupUi(this);
	setWindowIcon( QIcon(":/images/add.png") );
	ButtonOK->		setIcon( QIcon(":/images/ok.png") );
	ButtonCancel->	setIcon( QIcon(":/images/cancel.png") );

	//       accept  reject
	connect( ButtonOK,     SIGNAL(clicked()), this, SLOT(accept()) );
	connect( ButtonCancel, SIGNAL(clicked()), this, SLOT(reject()) );

	//     (0)
	ComboMonth->setCurrentIndex(0);
	//      
	on_ComboMonth_currentIndexChanged(0);

	//   ,   
	layout()->setSizeConstraint(QLayout::SetFixedSize);
}

void FormAdd::on_ComboMonth_currentIndexChanged(int i)
{
	//   ,    
	i++;
	// ,      (      1)
	int c = ComboDay->currentIndex();
	//        ,   
	if ( c == -1 ) c = 0;
	//   
	ComboDay->clear();

	//       
	QVector<int> CDays;
	//       0     1     2     3     4     5     6     7     8     9    10    11    12		-  
	CDays << 0 << 31 << 29 << 31 << 30 << 31 << 30 << 31 << 31 << 30 << 31 << 30 << 31; //	-    
	int max = CDays.at(i);

	//     1  max
	QString day = "";
	int d = 0;
	while ( d != max )
	{
		d++;
		//  d      ComboDay
		day = QString::number(d);
		if (d<10) { day = "0" + day; }
		ComboDay->addItem( day );
	}

	//      >   max  ,
	//        
	if ( c > max - 1 ) c = max - 1;
	//   ,      
	ComboDay->setCurrentIndex(c);
}

void FormAdd::on_EditName_textChanged()
{
	//      ,   OK 
	ButtonOK->setEnabled( EditName->text() != "" );
}
