#ifndef FORMMAIN_H
#define FORMMAIN_H

#include <QMainWindow>

#include "ui_FormMain.h"
#include "FormAdd.h"
#include "FormInfo.h"
#include "FormRemind.h"
#include "FormSettings.h"

class FormMain : public QMainWindow, public Ui::FormMain
{
	Q_OBJECT

	public:
		FormMain(); // 
		int remind(bool simple); //    ( )

		enum { MagicNumber = 0x7F51C883 }; //   -       
		enum WhereSetDate { ToNowhere, ToCurrent, ToAll }; //       -      

	protected:
		void closeEvent(QCloseEvent *event);	//   

	private slots:
		void addPerson(); //    
		void deletePerson(); //    
		void changePerson(); //    
		void infoPerson(); //    (  ,  )
		void about(); //  
		void settings(); // 
		void remindFromForm(); //       
		void ok(); //       
		void clearTable(); //  
		void showBD(int Y, int M); //          Label
		void showDate(const QDate date); //     
		void showMonth(int M); //     
		void tabChanged(int index); //    
		void doubleClicked(int r, int c); //     

	private:
		void setModified(bool mod); // ,    
		bool getModified(); // ,    
		void createMenu(); //    
		void setPerson(int row, QString PName, QString CDate); //     (   )
		void readSettings(); //  
		void writeSettings(); //  
		void sortAndSet(WhereSetDate WhatRow = ToAll); //        
		bool loadFile(); //  
		bool saveFile(); //  
		bool duplicateName(QString SearchName, int ChangeItem); //     (   )
		void infoRow(); //    ,        
		QString getMonth(int m); //      
		QString zodiac(int m, int d); //       
		int daysToBirthday(int m, int d); //    

		// 
		bool modified;			//    
		QString ProgramTitle;	//  
		QString ProgramVersion;	//  
		QString ProgramDate;	//    
		QString ProgramSite;	//  
		QString HomeDir;		//   ,    
		QString UserName;		//   (     )

		int SortBy;			//  (1 -  , 0 -  )
		int NameWidth;		//    ( )
		int RemindBy;		//        
		bool Remind;		//    
		bool LangRu;		//   (true - , false - )
		QString ViewStyle;	//   
		QString FileName;	// ,    
};

#endif
