#include <QtGui>

#include "FormRemind.h"

FormRemind::FormRemind(QWidget *parent, QString message, bool simple) : QDialog(parent, Qt::WindowStaysOnTopHint)
{
	// Qt::WindowStaysOnTopHint    ,      

	setupUi(this);
	setWindowIcon( QIcon(":/images/icon.png") );

	IsSimple = simple;

	//  remind     
	if (IsSimple)
	{
		ButtonClose->setIcon( QIcon(":/images/ok.png") );
		ButtonOpen->setVisible(false);
		LabelInfo->setVisible(false);
		connect( ButtonClose, SIGNAL(clicked()), this, SLOT(reject()) );
	}
	//  remind       -r
	else
	{
		ButtonOpen-> setIcon( QIcon(":/images/ok.png") );
		ButtonClose->setIcon( QIcon(":/images/cancel.png") );

		//       accept  reject
		connect( ButtonClose,	SIGNAL(clicked()), this, SLOT(reject()) ); // Close    ,   Esc  Enter 
		//    -   reject,    Open  accept
		connect( ButtonOpen,	SIGNAL(clicked()), this, SLOT(openMainWindow()) ); //    accetp,    
		//           

		sec = 21; // ,    
		updateInfo(); //    LabelInfo

		// ,       
		timerSec = new QTimer(this);
		connect( timerSec, SIGNAL(timeout()), this, SLOT(updateInfo()) );
		timerSec->start(1000);

		// ,    
		timerFade = new QTimer(this);
		connect( timerFade, SIGNAL(timeout()), this, SLOT(setNewConnection()) );
		timerFade->start( sec * 1000 - 4000 );

		//     (    3    )
		timerClose = new QTimer(this);
		connect( timerClose, SIGNAL(timeout()), qApp, SLOT(quit()) );
		timerClose->start( sec * 1000 + 3000 );
	}

	//    -     
	LabelMessage->setText(message);

	//   ,   
	layout()->setSizeConstraint(QLayout::SetFixedSize);
}



//   ר     
void FormRemind::enterEvent(QEvent *event)
{
	//       -r
	if ( ! IsSimple )
	{
		timerSec->stop();	//    stop,       
		timerFade->stop();
		timerClose->stop();
		setWindowOpacity(0.975);
		LabelInfo->setText
		(
			"<span style='color: #666; font-size: 7pt;'>" +
			tr("The window will not closed automatically.") +
			"</span>"
		);
	}
}



//    
void FormRemind::updateInfo()
{
	sec--;
	if ( sec < 0 ) sec = 0;
	LabelInfo->setText
	(
		"<span style='color: #666; font-size: 7pt;'>" +
		tr("The window will be closed in %1 sec.").arg( sec ) +
		"</span>"
	);
}



//        
void FormRemind::openMainWindow()
{
	timerSec->stop();	//    Open,         
	timerFade->stop();
	timerClose->stop();
	accept();
}



//    SIGNAL-SLOT      SEC 
void FormRemind::setNewConnection()
{
	timerFade->stop(); //  
	disconnect( timerFade, SIGNAL(timeout()), this, SLOT(setNewConnection()) ); //   
	connect( timerFade, SIGNAL(timeout()), this, SLOT(fadeOut()) ); //  ,    
	timerFade->start(50); //  
}



//   
void FormRemind::fadeOut()
{
	//   timerFade    50
	//   1  (1000 )   1000/50=20 
	//    4 ,   4    20*4=80 
	//    1   80    0.0125 -  ,  
	//      1 
	if (windowOpacity() > 0.02 )
	{
		setWindowOpacity( windowOpacity() - 0.0125 );
	}
	//       
	else
	{
		//     
		setWindowOpacity(0.02);
		//  
		timerFade->stop();
	}
}
