#include <QApplication>
#include <QTranslator>
#include <QSettings>
#include <QSharedMemory>
#include <QMessageBox>

#include "FormMain.h"

int main(int argc, char *argv[])
{
	QApplication app(argc, argv); //  Qt  

	//      
	//       ,  
	QSharedMemory global("Unique key for Birthdays programm");
	if ( ! global.create(1) )
	{
		QMessageBox::information(
					0,
					"Information",
					"The program is already launched",
					QMessageBox::Ok,
					QMessageBox::Ok );
		return 1;
	}

	QCoreApplication::setOrganizationName("birthdays");
	QCoreApplication::setApplicationName ("birthdays");

	//      
	QSettings lang;
	bool LangRu = lang.value("LangRu", false).toBool();

	//   
	QTranslator tran;
	if ( LangRu )	tran.load( "birthdays_ru.qm", ":/lang/" );
	else			tran.load( "birthdays_en.qm", ":/lang/" );
	app.installTranslator( &tran );

	FormMain mainWin; //    

	//    -r,     
	if ( ( argc == 2 ) and ( QString(argv[1]) == "-r" ) )
	{
		//       Close,  
		if ( mainWin.remind(false) == 0 ) return 0;
	}

	//   Open       ,
	//     
	mainWin.show();
	return app.exec();
}
